unit U_genius;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, interakt;

type
  TF_genius = class(TForm)
    lb_zugfolge: TListBox;
    b_start    : TButton;
    B_gesamt   : TButton;
    b_schritt  : TButton;
    b_weiter   : TButton;
    b_2000     : TButton;
    b_notbremse: TButton;
    b_ende     : TButton;
    e_anzahl: TEdit;
    Label1 : TLabel;
    Label2 : TLabel;
    Label3 : TLabel;
    Label4 : TLabel;
    Label5 : TLabel;
    Label6 : TLabel;
    Label7 : TLabel;
    Label8 : TLabel;
    Label9 : TLabel;
    Label10: TLabel;
    Label11: TLabel;
    procedure FormCreate      (Sender: TObject);
    procedure b_startClick    (Sender: TObject);
    procedure b_notbremseClick(Sender: TObject);
    procedure b_endeClick     (Sender: TObject);
    procedure b_weiterClick   (Sender: TObject);
    procedure b_2000Click     (Sender: TObject);
    procedure B_schrittClick  (Sender: TObject);
    procedure B_gesamtClick   (Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  F_genius: TF_genius;

implementation {$R *.DFM}

const n = 15;
type  t_belegfeld = array[1..n] of boolean;
      t_folgefeld = array[1..n,1..4] of byte;
const nf : t_folgefeld = ( ( 4, 6, 0, 0), ( 7, 9, 0, 0), ( 8,10, 0, 0),
                           ( 1, 6,11,13), (12,14, 0, 0), ( 1, 4,13,15),
                           ( 2, 9, 0, 0), ( 3,10, 0, 0), ( 2, 7, 0, 0),
                           ( 3, 8, 0, 0), ( 4,13, 0, 0), ( 5,14, 0, 0),
                           ( 4, 6,11,15), ( 5,12, 0, 0), ( 6,13, 0, 0) );
var   belegt      : t_belegfeld;
      zweitausend,
      schritt,
      ges_anzahl  : boolean;

procedure TF_genius.b_startClick(Sender: TObject);
var i, zaehler : integer;

   procedure suche( var belegt : t_belegfeld; tiefe : integer );
   var i, k : integer; b1,b2: string[1];
   begin
     if   tiefe = 14
     then begin
            inc(zaehler); e_anzahl.text := IntToStr(zaehler);
            if not ges_anzahl then
             if zweitausend
             then begin
                    if  zaehler mod 2000 = 0 then warte
                  end
             else warte;
          end
     else for i:=1 to 15 do
            if  belegt[i] = true then
            for k:=1 to 4 do
              if (nf[i,k] <> 0) and (belegt[nf[i,k]] = false)
                    and (belegt[(i + nf[i,k]) div 2] = true)
              then begin
                     belegt[i] := false; belegt[nf[i,k]] := true;
                     belegt[(i + nf[i,k]) div 2] := false;
                     if i<10 then b1:= ' ' else b1:= '';
                     if nf[i,k]<10 then b2:= ' ' else b2:= '';
                     lb_zugfolge.items.add
                        (b1+IntToStr(i)+' -> '+b2+IntToStr(nf[i,k]));
                     if schritt then warte;

                     suche ( belegt, tiefe+1 );

                     belegt[i] := true; belegt[nf[i,k]] := false;
                     belegt[(i + nf[i,k]) div 2] := true;
                     lb_zugfolge.items.delete(tiefe-1);
                   end;
   end;

begin
  lb_zugfolge.clear; zaehler := 0; zweitausend := false;
  for i:=1 to n do belegt[i] := true; belegt[1] := false;
  suche ( belegt,1 );
end;

procedure TF_genius.FormCreate(Sender: TObject);
begin
  init_interaktion;
  schritt:= false;
  ges_anzahl:= false
end;

procedure TF_genius.b_notbremseClick(Sender: TObject);
begin
  halt
end;

procedure TF_genius.b_endeClick(Sender: TObject);
begin
  close
end;

procedure TF_genius.b_weiterClick(Sender: TObject);
begin
  zweitausend := false; mach_weiter;
end;

procedure TF_genius.b_2000Click(Sender: TObject);
begin
  zweitausend := true; mach_weiter;
end;

procedure TF_genius.B_schrittClick(Sender: TObject);
begin
  schritt:= not schritt;
  if schritt then B_schritt.caption:= 'aus'
             else B_schritt.caption:= 'ein';
  B_gesamt.enabled:= not schritt;
end;

procedure TF_genius.B_gesamtClick(Sender: TObject);
begin
  ges_anzahl:= not ges_anzahl;
  if ges_anzahl then B_gesamt.caption:= 'aus'
                else B_gesamt.caption:= 'ein';
  B_schritt.enabled:= not ges_anzahl;
  B_weiter.enabled := not ges_anzahl;
  B_2000.enabled   := not ges_anzahl;
  mach_weiter
end;

end.
